# frozen_string_literal: true

module Referator
  class Note
    attr_reader :index, :reference

    def initialize(index, reference)
      self.index = index
      self.reference = reference
    end

    def to_h
      @to_h ||= reference.to_h.merge(index:).freeze
    end

  private

    def index=(index)
      index = Integer index
      raise ArgumentError, 'Invalid index' unless index.positive?

      @index = index
    end

    def reference=(reference)
      unless reference.is_a? Reference
        raise TypeError, "Expected #{Reference}, got #{reference.class}"
      end

      @reference = reference
    end
  end
end
