#!/usr/bin/env ruby
# frozen_string_literal: true

require 'erb'
require 'json'
require 'pathname'

def template(filename)
  pathname = Pathname.new(__dir__).join(filename).expand_path.freeze
  ERB.new(pathname.read, trim_mode: '-').tap do |erb|
    erb.filename = pathname.to_s.freeze
  end.freeze
end

name = "#{ARGV[0]}.erb".freeze
vars = JSON.parse($stdin.read).freeze

puts template(name).result_with_hash(vars).strip
